<?php
/*
Plugin Name: Plurk2 Plugin for Wordpress
Plugin URI: http://yuann.tw/?p=1069
Description: This plugin is a tool for <a href="http://plurk.tw/" target="_blank">Plurk2</a>. Just simply put [Plurk url] in your article like [http://www.plurk.com/p/(5 digits)].
Version: 0.1
Author: Johnson.Wang
Author URI: http://yuann.tw/

*/

function plurk2_install() {
	$plurk2_defaultType	= get_option("plurk2_defaultType");
	$plurk2_defaultWidth	= get_option("plurk2_defaultWidth");
	
	if (! $plurk2_defaultType) {
		$plurk2_defaultType = 1;
		add_option("plurk2_defaultType", $plurk2_defaultType, "Default type for Plurk Plug");
	}

	if (! $plurk2_defaultWidth) {
		$plurk2_defaultWidth = 500;
		add_option("plurk2_defaultWidth", $plurk2_defaultWidth, "Default width for Plurk Plug");
	}
}

//admin panel
function plurk2_adminPanel() {
		add_options_page('Plurk2 options', 'Plurk2', 10,
			basename(__FILE__), 'plurk2_optionsSubpanel');
}

function plurk2_optionsSubpanel() {
	echo "<div class=\"wrap\"><h2>Plurk2 Options</h2>";

	if($_POST['action'] == "save") {
		echo "<div class=\"updated fade\" id=\"limitcatsupdatenotice\"><p>" . __("Configuration <strong>updated</strong>.") . "</p></div>";
		//updating stuff..
		update_option("plurk2_defaultType", $_POST["pp_type"]);
		update_option("plurk2_defaultWidth", $_POST["pp_width"]);
	}

	$plurk2_defaultType	= get_option("plurk2_defaultType");
	$plurk2_defaultWidth	= get_option("plurk2_defaultWidth");
	
	$plurk2_style_name[1]="Clean Style";
	$plurk2_style_name[2]="Hana Style";
	$plurk2_style_name[3]="ph2 Style";
	
	echo "<form method=\"post\">";
	echo "<table class=\"form-table\"><tr><th><label>Plurk Plug default type:</th><td>";
	
	for ($p=1;$p<=count($plurk2_style_name);$p++) {
		echo "<input type=\"radio\" name=\"pp_type\" value=\"$p\"";
		if ($p==$plurk2_defaultType) echo " checked";
		echo ">".$plurk2_style_name[$p]."<br>";
	}
	echo "</td></tr><tr>";
	echo "<th><label>Plurk Plug default width:</th><td><input type=\"text\" name=\"pp_width\" size=\"5\" value=\"$plurk2_defaultWidth\"></td></tr></table>";
	echo "<input type=\"hidden\" name=\"action\" value=\"save\"><input type=\"submit\" value=\"Save\"></form></div>";
}

function plurk2_check($the_content) {
	if(strpos($the_content, "[http://www.plurk.com/p/")!==FALSE  ) {
		
		$char_codes = array('&#215;');
		$replacements = array("x");
	    $the_content=str_replace($char_codes, $replacements, $the_content);
	    
		preg_match_all("/\[http:\/\/www.plurk.com\/p\/([a-zA-Z0-9\-\_]{5})\]/", $the_content, $matches, PREG_SET_ORDER); 
		foreach($matches as $match) { 
			
			$the_content = preg_replace("/\[http:\/\/www.plurk.com\/p\/([a-zA-Z0-9\-\_]{5})\]/", plurk2_tag($match[1]), $the_content, 1);	
		}
		
	}
    return $the_content;
}

function plurk2_tag($plurk_sn) {
	$plurk2_Type		= get_option("plurk2_defaultType");
	$plurk2_Width	= get_option("plurk2_defaultWidth");

	switch ($plurk2_Type) {
		case "1":
			$plurk2_replacestring='<script type="text/javascript" language="JavaScript" src="http://plurk.tw/java/plurk.php?url='.$plurk_sn.'"></script>';
			break;
		case "2":
			$plurk2_replacestring='<script type="text/javascript" language="JavaScript" src="http://plurk.tw/java/plurk_hana.php?url='.$plurk_sn.'&width='.$plurk2_Width.'"></script>';
		break;
		case "3":
			$plurk2_replacestring='<script type="text/javascript" src="http://plurk.tw/java/jquery-1.3.1.min.js"></script><script type="text/javascript" src="http://plurk.tw/java/ph2.js"></script><script type="text/javascript" language="JavaScript" src="http://plurk.tw/java/ph2.php?url='.$plurk_sn.'&width='.$plurk2_Width.'"></script>';
		break;
	}
	return $plurk2_replacestring;	
}

//hooks
add_action('admin_menu', 'plurk2_adminPanel');
add_filter('the_content', 'plurk2_check', 100);
add_action('plugins_loaded', 'plurk2_install');
?>
